/*
GoSkola24API
Copyright (C) 2024, Zervó Zadachin

DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License version 3
as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License version 3 for more details.

This program incorporates external libraries for certain functionalities.
These libraries are covered by their respective licenses, and their usage
agreements are as outlined in their respective documentation or source
code.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package utility

import (
	"errors"
)

func GetRendererKey() (_key string, _error error) {
	response, err := Request(nil, "get/timetable/render/key")
	if err != nil {
		return "", errors.New("could not get render key: " + err.Error())
	}

	// Assert the response type to a map[string]interface{}
	responseMap, ok := response.(map[string]interface{})
	if !ok {
		return "", errors.New("unexpected response type")
	}

	// Extract the "key" value using type assertion
	keyValue, ok := responseMap["key"].(string)
	if !ok {
		return "", errors.New("missing or invalid \"key\" field in response")
	}

	return keyValue, nil
}
